<template>
  <div v-if="isVisible">
    <v-card :loading="isLoadingCumplimientoPuntajePorNegocio">
      <IdGrafico id="006" />
      <div class="gris">
        <h2 class="tituloBloque">
          Distribución del cumplimiento por negocio a nivel
          <span
            v-if="
              globalFilters &&
                globalFilters.filters.nivel_geografico.descripcion
            "
            class="bold keep-spaces"
            >{{
              " " + globalFilters.filters.nivel_geografico.descripcion
            }}</span
          >
        </h2>
        <div class="divCumplimiento scrollY">
          <v-simple-table fixed-header class="tblVue tblDistribucion">
            <template v-slot:default>
              <thead class="tblHead">
                <tr>
                  <th class="text-center">Negocio</th>
                  <th class="text-center">Puntos de contacto #</th>
                  <th class="text-center">Cumple #</th>
                  <th class="text-center">Cumple %</th>
                  <th class="text-center">Puntaje</th>
                </tr>
              </thead>
              <tbody class="tblBody">
                <template v-for="(itemNegocio, indexItemNegocio) in negocios">
                  <tr :key="indexItemNegocio">
                    <td class="cantidad text-center">
                      <v-img
                        :contain="true"
                        :aspect-ratio="1"
                        position="center"
                        class="image-logo"
                        :src="itemNegocio.logo_image"
                        :lazy-src="itemNegocio.logo_image"
                        height="25"
                        width="65"
                      />
                    </td>
                    <td class="cantidad">{{ itemNegocio.totales }}</td>
                    <td class="cantidad">{{ itemNegocio.cumple }}</td>
                    <td class="cantidad">{{ itemNegocio.porcentaje }}</td>
                    <td class="cantidad">
                      <div
                        class="circle"
                        :style="{ backgroundColor: itemNegocio.rango.detalle }"
                      ></div>
                      {{ itemNegocio.puntaje }}
                    </td>
                  </tr>
                </template>
              </tbody>
            </template>
          </v-simple-table>
        </div>
      </div>
    </v-card>
  </div>
</template>
<style scoped>
.image-logo {
  margin: auto;
}
.gris {
  width: 100%;
  margin: 0px auto;
  padding: 15px 15px;
  background-color: #faf9f9;
  -moz-box-shadow: 0 0px 1px rgb(226, 222, 222);
  -webkit-box-shadow: 0 0px 1px rgb(226, 222, 222);
  box-shadow: 0 0px 1px rgb(226, 222, 222);
  margin-bottom: 15px;
  text-align: justify;
  height: 100%;
}
.tituloBloque {
  font-size: 18px;
  color: #000;
  padding-bottom: 15px;
  font-family: "Avenir_Next_Regular", sans-serif;
}
.bold {
  font-family: "Avenir_Next_Bold", sans-serif;
}
</style>
<style scoped>
.tblVue {
  width: 100%;
  background-color: #fcfcfc !important;
}
.tblVue .tblHead tr th {
  padding: 5px 10px 6px 10px;
  color: #333333 !important;
  text-align: center;
  font-weight: 100;
  border-bottom: 1px solid #3e3d3d !important;
  font-size: 14px;
  font-family: "Avenir_Next_Bold";
  min-width: 87px;
}
.tblVue .v-data-table__wrapper {
  overflow-x: hidden !important;
}
.tblVue .tblBody tr td {
  padding: 7px 10px 7px 10px;
  color: #606664;
  font-size: 13px;
  text-align: center;
  border-bottom: 1px solid #bebebe !important;
}
.tblVue .tblBody tr:last-of-type td {
  border-bottom: none !important;
}
.theme--light.v-data-table tbody tr:hover {
  background: #eeeeee !important;
}
.tblVue tbody tr td.cantidad {
  width: 120px;
  margin: auto;
  text-align: center;
  color: #000;
}
.tblVue tbody tr td .circle {
  width: 15px;
  height: 15px;
  border-radius: 100%;
  display: inline-block;
  margin-right: 5px;
}
.tblVue tbody tr td img {
  width: 65px;
}
.tblVue tr.total td {
  font-family: "Avenir_Next_Demi_Bold";
}
.divCumplimiento {
  width: 100%;
  margin: 0 auto;
  border: 1px solid #bfbfbf;
  padding-top: 10px;
}
.divCumplimiento .tblVue {
  padding: 15px;
  box-sizing: border-box;
}
.puntajeAmarillo {
  background-color: #f3c75c;
}
.scrollY {
  overflow-y: scroll;
}
</style>
<script>
import store from "@/store";
import axios from "axios";
import IdGrafico from "@/views/secure/sistema-informacion/dashboards/commons/IdGraficoLabel.vue";
const serviceCommons = store.state.serviceCommons;
export default {
  name: "Component-CumplimientoPuntajePorNegocio",
  props: {
    methodsSemaforoParent: Object,
    globalFiltersParent: Object
  },
  components: {
    IdGrafico
  },
  data() {
    return {
      isLoadingCumplimientoPuntajePorNegocio: true,
      isPersentValue: true,
      methodsSemaforo: null,
      globalFilters: null,
      isVisible: null,
      negocios: []
    };
  },
  methods: {
    listenSearchConsulta(globalFilters) {
      if (globalFilters.final_filters.id_negocio === 0) {
        this.isVisible = true;
        this.globalFilters = globalFilters;
        this.getCumplimientoPuntajePorNegocio();
      } else {
        this.isVisible = false;
      }
    },
    listenSemaforo(methodsSemaforo) {
      this.methodsSemaforo = methodsSemaforo;
    },
    getCumplimientoPuntajePorNegocio() {
      this.isLoadingCumplimientoPuntajePorNegocio = true;
      const self = this;
      const contentFiltros = {
        filtros: this.globalFilters.final_filters
      };
      axios
        .post(
          "franquicia/dashboard/secure/grafico/get/cumplimiento/puntaje/negocio/nacional",
          contentFiltros
        )
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              if (data) {
                self.setCumplimientoPuntajePorNegocio(data.negocios);
              }
            } else {
              self.setCumplimientoPuntajePorNegocio([]);
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {
          self.isLoadingCumplimientoPuntajePorNegocio = false;
        });
    },
    setCumplimientoPuntajePorNegocio(negocios) {
      negocios.forEach((itemNegocio) => {
        itemNegocio.logo_image = serviceCommons.getLogoImageByIdNegocio(
          itemNegocio.id_negocio
        );
        if (
          this.methodsSemaforo &&
          this.methodsSemaforo.getRangoByLimit(itemNegocio.puntaje)
        ) {
          let rango = this.methodsSemaforo.getRangoByLimit(itemNegocio.puntaje);
          itemNegocio.rango = {
            detalle: rango.detalle
          };
        } else {
          itemNegocio.rango = {
            detalle: ""
          };
        }
      });
      this.negocios = negocios;
    }
  },
  mounted() {
    this.$root.$on("searchconsulta", this.listenSearchConsulta);
    this.$root.$on("rangoloaded", this.listenSemaforo);
  },
  created() {
    this.methodsSemaforo = this.methodsSemaforoParent;
    this.globalFilters = this.globalFiltersParent;
    if (this.globalFilters && this.methodsSemaforo) {
      this.getCumplimientoPuntajePorNegocio();
    }
  }
};
</script>
